/*******************************************
ͺ:OCMJ320240T280_1A
MCU :89S52
:ʾ
д:MO
:2012/9/5
********************************************/

#include <reg52.h>
#include "pic1.h"

#define uchar      unsigned char
#define uint       unsigned int

#define MHz     1000000U           //  MHz
#define gCLK    (11.0592*MHz)      // ϵͳʱƵ(22.1184*MHz)	 (11.0592*MHz) 
#define UART_BAUD   19200           // õĲ

sbit LCD_BUSY=P3^4;  //H:յݲڴ,L:пɽ

sbit CHK_INT= P3^2;	//ж
sbit res= P3^3;	//λ

//sbit input =P3^2;
uchar X[4];
uchar RevTab[10];
char count=0;
void send_stop_word(void);
/**********nusʱӳ*************/
void Delay_Nus(uint n)
{
	while(n--);
}

/**********nmsʱӳ*************/
void Delay_Nms(uint n)
{
	uint i,j;
	for(i=0;i<n;i++)
		for(j=0;j<125;j++)
			;
}

/**********д*************/
void SendData(uchar content)
{  

  /* ȴͻΪ */
   //while(LCD_BUSY==1);
   /* ݷ뻺 */
   SBUF = content;
   while(TI==0);
   TI=0;
  // Delay_Nus(10);
  
}
/*****************UART*****************/
unsigned char USART_Receive( void )
{
	while(RI==0);
	RI=0;
  	return SBUF;
}

/**********дݵLCD*************/
void SendDataToLCD(uchar cmd,uchar numh,uchar numl)
{
	SendData(0xfd);
	//SendData(0x00);
	SendData(cmd);
	SendData(numh);
	SendData(numl);
}


/**************ʾص******************/
void Display_bit(void)
{
	uint i,k;
	SendDataToLCD(0x21,0,0);
	for(k=0;k<240;k++)
	{
		for(i=0;i<320;i++)
		{
			SendData(i>>8);
			SendData(i);
			SendData(k>>8);
			SendData(k);
		}
	} 
	send_stop_word();
}

/************ʾ*****************/
void Display_Chn(uchar const *chn,uchar Type)
{
	uchar i;
	
	SendDataToLCD(Type,0,0);
	SendData(0);
	SendData(0);
	SendData(0);
	SendData(0);

	for(i=0;i<70;i++)
	{
		SendData(chn[i*2]);
		SendData(chn[i*2+1]);
	}
	send_stop_word();
}
uint strlen(char *string)
{
	uint len=0;
	while(*string++) len++;
	return len;
}
/************ʾģʽʾӦַ*****************/
//mode:0x12 
//mode:0x13 
//mode:0x14 
void PutString(uint x,uint y,uchar mode,char *string)   
{
	uint len;
	len=strlen(string); 
	len=len+5;
	SendData(0xfd);
	SendData(mode);	
	SendData(len/256);
	SendData(len%256);
	
	SendData(x/256);
	SendData(x%256);
	SendData(y/256);
	SendData(y%256);
	
	while(*string != '\0')
	{
		SendData(*string);
		string++;
	}
	//UART0_SendByte('\0');

 	send_stop_word();
}

/***********************************/
//UART0 initialize
void uart0_init(void)
{
//ͨ÷ 51Ƭ UART 0 ʼ
    SCON  = 0x50;               // Mode 1: 8-bit UART, 
    TMOD |= 0x20;               // ʱ1 Mode 2: 8-Bit reload
    PCON  = 0x80;               // SMOD = 1
    TH1   = 256 - (uchar)(gCLK/192.0F/UART_BAUD);
    TR1   = 1;                  // ʱ 1 
    ES    = 1;                  // ж
}

/**************ʾ9600ͼ******************/
void Display_tab1(uchar const *pp)
{
	uint k;
	
	for(k=0;k<9600;k++)
	{
	  SendData(pp[k]);	
	}
}

void Clear_Disp(void)
{
	 SendData(0xfd);	
  	 SendData(0x02);
  	 SendData(0x00);	
  	 SendData(0x00);
  	 send_stop_word();
}	

void SetTouchPanMode(uchar Type)
{
	SendDataToLCD(0x52,0,1);
	SendData(Type);
	send_stop_word();
}

void TouchTest(void)
{
	SendDataToLCD(0x53,0,4);
	SendData(0x55);
	SendData(0xaa);
	SendData(0x5a);
	SendData(0xa5);
	send_stop_word();
}
void TouchTestFun(void)
{
	uchar DelayTime=0;
	uchar TouchTime=0;
	//EA=0;
	SetTouchPanMode(0x01);	//
	TouchTest();
	while(DelayTime<100)
	{
		Delay_Nms(20);
		DelayTime++;
		if(CHK_INT==0)
		{
			while(CHK_INT==0);
			if(TouchTime<4)
			{
				TouchTime++;
			}
			DelayTime=0;
		}
	}
	SetTouchPanMode(0);	//ش
	//EA=1;
}

void TouchAdj(void)
{
	SendDataToLCD(0x50,0,4);
	SendData(0x55);
	SendData(0xaa);
	SendData(0x5a);
	SendData(0xa5);
	send_stop_word();
}

void TouchAdjTest(void)
{
	uchar DelayTime=0;
	uchar TouchTime=0;
	//EA=0;
	SetTouchPanMode(0x01);	//
	TouchAdj();	//У׼
	
	while(DelayTime<100)
	{
		Delay_Nms(20);
		DelayTime++;
		if(CHK_INT==0)
		{
			while(CHK_INT==0);
			if(TouchTime<4)
			{
				TouchTime++;
			}
			DelayTime=0;
		}
	}
	if(TouchTime<4)
	{
		SetTouchPanMode(1);
	}
	//EA=1;
}

/******************************************/
void matrix_disp(uchar matrix_type,uint matrix_x,uint matrix_y,uint matrix_w,uint matrix_h)
{
	SendDataToLCD(0x27,0,0);
	SendData(matrix_type);
	SendData(matrix_x>>8);
	SendData(matrix_x);
	SendData(matrix_y>>8);
	SendData(matrix_y);
	
	SendData(matrix_w>>8);
	SendData(matrix_w);
	SendData(matrix_h>>8);
	SendData(matrix_h);
	send_stop_word();
}

/************************************/
void disp_round(uchar Mode,uint x0,uchar y0,uchar k)
{
	uchar r;
	SendDataToLCD(0x26,0,0);
	//for(r=0;r<255;r=r+k)
	//{
		SendData(Mode);
		SendData(x0>>8);
		SendData(x0);
		SendData(y0>>8);
		SendData(y0);
		SendData(k);
	//}
	send_stop_word();		
}
void send_stop_word(void)
{
	SendData(0xDD);	
	SendData(0xCC);	
	SendData(0xBB);	
	SendData(0xAA);	
}

void Disp_Full_Screen_Pic(void)
{
	uchar i;
	for(i=0x11;i<0x42;i++)
	{	
		if((i&0x0f)==10)
		{
			i=(i&0xf0)+0x10;
		}
	  	SendDataToLCD(0x30,0,0);
		SendData(0);
		SendData(i);
		send_stop_word();
		Delay_Nms(150);
	}
}

void ReceiveInt(void) interrupt 4	using	1
{
	if(RI)
	{
  		RevTab[count]=SBUF;
  		RI=0;
  		count++;
  	}
  	/*
  	if(TI)
  	{
		TI=0;	
  	}
  	*/
}

void HandShave(void)
{
	uchar *pp;
	char tab[10];
	EA=1;
	RI=0;
	count=0;
	SendDataToLCD(0x00,0,0x00);	
	send_stop_word();
	
	while(count!=2);

	PutString(0,0,0x12,"ģ汾: V");
	count=0;
	tab[0]=(RevTab[0]>>4)+0x30;
	tab[1]='.';
	tab[2]=(RevTab[0]&&0x0f)+0x30;
	tab[3]='\0';
	PutString(136,0,0x12,tab);
	
	PutString(0,16,0x12,"Ŀǰʣ");
	switch(RevTab[1])
	{
		case 0:	PutString(96,16,0x12,"1200");
		break;
		case 1:	PutString(96,16,0x12,"2400");
		break;
		case 2:	PutString(96,16,0x12,"4800");
		break;
		case 3:	PutString(96,16,0x12,"9600");
		break;
		case 4:	PutString(96,16,0x12,"14400");
		break;		
		case 5:	PutString(96,16,0x12,"19200");
		break;
		case 6:PutString(96,16,0x12,"38400");
		break;
		case 7:	PutString(96,16,0x12,"56000");
		break;
		case 8:	PutString(96,16,0x12,"57600");
		break;
		case 0xff:PutString(96,16,0x12,"115200");
		break;	
		default:
		break;	
	}
	EA=0;
}

void BackLight(uchar Type)
{
	SendDataToLCD(Type,0,0);
	send_stop_word();

}
void BuzzerTpye(uchar Type,uchar time)
{
	SendDataToLCD(0x0d,0,0x02);
	SendData(Type);
	SendData(time);
	send_stop_word();
}
void DrawLine(void)
{
	SendDataToLCD(0x23,0,0x00);
	SendData(0);
	SendData(170);
	SendData(0x00);
	SendData(60);
	
	SendData(0);
	SendData(180);
	SendData(0x00);
	SendData(0x14);
	
	SendData(0);
	SendData(240);
	SendData(0x00);
	SendData(0x24);
	
	SendData(1);
	SendData(46);
	SendData(0x00);
	SendData(0x08);

	send_stop_word();
}
void SanJiaoXing(void)
{
	SendDataToLCD(0x28,0,0x00);
	SendData(0);
	
	SendData(0);
	SendData(120);
	SendData(0x00);
	SendData(100);
	
	SendData(0);
	SendData(130);
	SendData(0x00);
	SendData(150);
	
	SendData(0);
	SendData(190);
	SendData(0x00);
	SendData(120);
	
	SendData(1);
	
	SendData(0);
	SendData(120);
	SendData(0x00);
	SendData(160);
	
	SendData(0);
	SendData(140);
	SendData(0x00);
	SendData(200);
	
	SendData(0);
	SendData(190);
	SendData(0x00);
	SendData(180);
	send_stop_word();
	
}
void DraWellipse(void)
{
	SendDataToLCD(0x29,0,0x00);
	SendData(0);
	
	SendData(0);
	SendData(250);
	SendData(0x00);
	SendData(120);
	
	SendData(0);
	SendData(30);
	SendData(0x00);
	SendData(20);
	
	SendData(1);	
	
	SendData(0);
	SendData(250);
	SendData(0x00);
	SendData(170);

	SendData(0);
	SendData(40);
	SendData(0x00);
	SendData(20);
	send_stop_word();	
}

void DispFullPic(uint PicID)
{
	SendDataToLCD(0x30,0,0x02);
	SendData(PicID>>8);
	SendData(PicID);
	send_stop_word();
}
/**************************/
void main (void)
{
	Delay_Nms(1000);
	uart0_init();
	Delay_Nms(100);	
	//send_stop_word();	
	//Clear_Disp();
//	EA=1;
	while(1)
	{
		HandShave();
		Delay_Nms(1000);	
		BackLight(0x09);
		Delay_Nms(1000);	
		BackLight(0x0a);
		Clear_Disp();
		Display_Chn(chn,0x12);
		Delay_Nms(1000);	
		Clear_Disp();
		Display_Chn(chn,0x13);
		Delay_Nms(1000);	
		Clear_Disp();
		Display_Chn(chn,0x14);
		Delay_Nms(1000);	
		BuzzerTpye(0x01,0x05);
		// Display_bit();
		// Delay_Nms(1000);
		Clear_Disp();
		disp_round(0,60,60,25);
		disp_round(1,120,60,25);
		DrawLine();
		matrix_disp(0,20,100,50,200);
		matrix_disp(1,60,100,100,200);
		SanJiaoXing();
		DraWellipse();
		Delay_Nms(1000);
		DispFullPic(0);
		Delay_Nms(1000);
		TouchAdjTest();
		Delay_Nms(1000);
		TouchTestFun();
		Delay_Nms(1000);
		
 
	/*	 //Clear_Disp();
		 //SendData(0xaa);
		 */
		 //Disp_Full_Screen_Pic();
		 //Delay_Nms(1000);
    }
}
